Unit Animate;

INTERFACE

Uses Graph,Dos,Toetsen,Timer;

Type  ByteSet       = Set Of Byte;

      _Sprite_      = RECORD
                        Buffer : Array[1..15*15] Of Byte;
                        XRow   : INTEGER;
                        YRow   : INTEGER;
	                Xpos   : INTEGER;
	                Ypos   : INTEGER;
	                LastX  : INTEGER;
	                LastY  : INTEGER;
                        Active : Boolean;
                      END;

      _SpriteWijzer = ^_SpriteDef;
      _SpriteDef    = RECORD
                       Buffer : Array[1..15,1..15] Of Byte;
                     END;

      _FontWijzer   = ^_FontDef;
      _FontDef      = RECORD
                       Buffer : Array[1..8,1..8] Of Byte;
                     END;

      _ScreenWijzer = ^_ScreenDef;
      _ScreenDef    = RECORD
                       Buffer : Array[1..14,1..24] Of Byte;
                     END;

      _SpriteMemory = Array[0..250] Of _SpriteWijzer;
      _ScreenMemory = Array[1..250] Of _ScreenWijzer;
      _FontMemory   = Array[0..255] Of _FontWijzer;

      _PaletteRec   = Record
                        Red   : Byte;
                        Green : Byte;
                        Blue  : Byte;
                      End;
      _PaletteArr   = Array [0..255] of _PaletteRec;


Var   _DiskMan       : _Sprite_;
{      _DiskManBuf    : _Sprite;}
      _SpriteRec     : _SpriteMemory;
      _SpriteOnes    : _SpriteDef;
      _ScreenRec     : _ScreenMemory;
      _ScreenOnes    : _ScreenDef;
      _FontRec       : _FontMemory;
      _FontOnes      : _FontDef;
      _SpriteFile    : File Of _SpriteDef;
      _ScreenFile    : File Of _ScreenDef;
      _FontFile      : File Of _FontDef;
      _Palette       : _PaletteArr;
      _BewaarPalette : _PaletteArr;
      _PaletteBuffer : _PaletteArr;
      _MAX_SCREEN    : Word;
      _MAX_SPRITE    : Word;
      _MAX_FONT      : Word;



Procedure Init_ModeX(Mode,MaxXpos,MaxYpos,Pages : Integer);
Procedure DrawSprite(SNr : Byte; X,Y : Word);
Procedure ClearAll;
Procedure ClearFirst;
Procedure ClearSecond;

Procedure Game_Init;
Procedure Game_Stop;
Procedure SetPalette;
Procedure ReadScreen(S : String; Max : Word);
Procedure ReadSprite(S : String; Max : Word);
Procedure ReadFont(S : String; Max : Word);
Procedure ReadPalette(S : String);
Procedure GetScreen(VAR Bld : _ScreenDef; Nr : Word);
Procedure Init_Screen(Bld            : _ScreenDef;
                      DLopen,OpEten,
                      OpBouw,Vijand  : ByteSet;
                      XPos,YPos      : Word);


Procedure Start_Animate(VAR _STOP : Boolean);

IMPLEMENTATION

{$I MODE.INC}

Const BITS = 3;
      _Leeg       = 0;
      _DMStil     = 2;
      _DMDood     = 3;
      _DMLinks1   = 4;
      _DMLinks2   = 5;
      _DMRechts1  = 6;
      _DMRechts2  = 7;

      _DM_Links   = 1;
      _DM_Rechts  = 2;
      _DM_Onder   = 3;
      _DM_Boven   = 4;

Var   _DiskManBoolean : Boolean;
      _DiskManBits,
      _LinksRechts,
      _DiskLaatste,
      _Animatie,
      _XPos,
      _YPos           : Word;
      _HuidigeScreen  : _ScreenDef;
      _DOORLOPEN      : Set Of Byte;
      _CurrentPage,
      _LastPage       : Integer; {PAGE FLIPPING}


Procedure Error(S : String);
Begin
  WriteLn(S);
  Halt(255);
End;

Procedure Init_ModeX(Mode,MaxXpos,MaxYpos,Pages : Integer);
Begin
  {QUICK & DIRTY VOOR ROBERT}
  If SET_VGA_MODEX(Mode,MaxXpos,MaxYpos,Pages) = 0 Then Begin
    Game_Stop;
    Error('Error Init Mode...');
  End;
End;

Procedure DrawSprite(SNr : Byte; X,Y : Word);
Begin
  Draw_BitMap(_SpriteRec[SNr]^.Buffer,X,Y,15,15);
End;

Procedure ClearAll;
Begin
  Set_Active_Page(0);
  Clear_VGA_Screen(0);
  Set_Display_Page(0);
End;


Procedure ClearFirst;
Begin
  Set_Active_Page(0);
  Clear_VGA_Screen(0);
  Set_Display_Page(1);
End;

Procedure ClearSecond;
Begin
  Copy_Page(0,1);
  Copy_Page(0,2);
  Set_Display_Page(0);
End;



{************************************}

Procedure BufToDMan(Van : Byte);
Begin
  Move(_SpriteRec[Van]^,_DiskMan.Buffer,SizeOf(_SpriteRec[Van]^));
End;


Procedure RemoveAllSprites;
Var I : Byte;
Begin
  Copy_Bitmap(2,_DiskMan.LastX,_DiskMan.LastY,_DiskMan.LastX+15,
      _DiskMan.LastY+15,_LastPage,_DiskMan.LastX,_DiskMan.LastY);
{
  For I := 1 To MAXALIENS Do
    Copy_Bitmap(2,Vijand[I].LastX,Vijand[I].LastY,Vijand[I].LastX+B,
        Vijand[I].LastY+H,LastPage,Vijand[I].LastX,Vijand[I].LastY);
}
End;


Procedure UpDateAllSprites;
Var I : Word;
Begin
  If _DiskMan.Active = True Then Begin
    _DiskMan.LastX := _DiskMan.XPos;
    _DiskMan.LastY := _DiskMan.YPos;
  End;
{
  For I := 1 To MAXALIENS Do If Vijand[I].Active = True Then Begin
    Vijand[I].LastX := Vijand[I].Xpos;
    Vijand[I].LastY := Vijand[I].Ypos;
  End;
}
End;


{Alle Sprites naar Scherm}
Procedure DrawAllSprites;
Var I : Byte;
Begin
  If _DiskMan.Active = True Then
    TDraw_Bitmap(_DiskMan.Buffer,_DiskMan.XPos,_DiskMan.YPos,15,15);
{
  For I := 1 To MAXALIENS Do If Vijand[I].Active = True Then
    TDraw_Bitmap(Vijand[I].Buffer,Vijand[I].XPos,Vijand[I].YPos,B,H);
}
End;

Function Exist(FileName : String) : Boolean;
Var SR : SearchRec;
Begin
  FindFirst(FileName, ReadOnly + Hidden + SysFile, SR);
  Exist := (DosError = 0) and (Pos('?', FileName) = 0) and
            (Pos('*', FileName) = 0);
End;

Procedure Game_Stop; ASSEMBLER;
ASM
  Mov AH,0
  Mov AL,3
  Int 10h
END;

Procedure Game_Init;
Begin
  If _MAX_SCREEN = 0 Then Error('Screens not loaded...');
  If _MAX_SPRITE = 0 Then Error('Sprites not loaded...');
  If _MAX_FONT   = 0 Then Error('Fonts not loaded...');
  If SET_VGA_MODEX(6,360,240,3) = 0 Then Begin
    Game_Stop;
    Error('Error Init Mode...');
  End;
  SetPalette;
End;

{$I PALETTE.INC}

Procedure ReadScreen;
Var Count : Word;
Begin
  If Not Exist(S) Then Error(S+' Not Found...') Else Begin
    Assign(_ScreenFile,S);
    Reset(_ScreenFile);
    _MAX_SCREEN := Max;
    For Count := 1 To Max Do Begin
      Read(_ScreenFile,_ScreenOnes);
      GetMem(_ScreenRec[Count],SizeOf(_ScreenOnes));
      Move(_ScreenOnes,_ScreenRec[Count]^,SizeOf(_ScreenOnes));
    End;
    Close(_ScreenFile);
  End;
End;


Procedure ReadSprite;
Var Count : Word;
Begin
  If Not Exist(S) Then Error(S+' Not Found...') Else Begin
    Assign(_SpriteFile,S);
    Reset(_SpriteFile);
    _MAX_SPRITE := Max;
    For Count := 0 To Max Do Begin
      Read(_SpriteFile,_SpriteOnes);
      GetMem(_SpriteRec[Count],SizeOf(_SpriteOnes));
      Move(_SpriteOnes,_SpriteRec[Count]^,SizeOf(_SpriteOnes));
    End;
    Close(_SpriteFile);
  End;
End;

Procedure ReadFont;
Var Count : Word;
Begin
  If Not Exist(S) Then Error(S+' Not Found...') Else Begin
    Assign(_FontFile,S);
    Reset(_FontFile);
    _MAX_FONT := Max;
    For Count := 0 To Max Do Begin
      Read(_FontFile,_FontOnes);
      GetMem(_FontRec[Count],SizeOf(_FontOnes));
      Move(_FontOnes,_FontRec[Count]^,SizeOf(_FontOnes));
    End;
    Close(_FontFile);
  End;
End;

Procedure ReadPalette;
Var T       : Byte;
    F       : File;
    Gelezen : Word;

Begin
  If Exist(S) Then Begin
    Assign(F,S);
    Reset(F,1);
    BlockRead(F,_Palette,SizeOf(_Palette),Gelezen);
    Close(F);
  End Else Error(S+' Not found...');
End;

Procedure GetScreen;
Begin
  If (Nr > 0) And (Nr < _MAX_SCREEN+1) Then Begin
    Bld := _ScreenRec[Nr]^;
  End Else Error('Error GetScreen...');
End;

Procedure Init_New_Screen;
Begin
  FillChar(_DiskMan,SizeOf(_DiskMan),0);
  _DiskManBoolean := False;
  _DiskManBits := 0;
  _DiskLaatste := 0;
  _LinksRechts := 0;
  _CurrentPage := 1;
  _LastPage := 0;
  _Animatie := 0;
End;

Procedure Init_Screen;
Var X,Y,I : Word;
Begin
  {LEES GEGEVENS OVER VIJANDEN EN DISKMAN}
  Set_Active_Page(0);
  Clear_VGA_Screen(0);
  Set_Display_Page(1);
  Init_New_Screen;
  _HuidigeScreen := Bld;
  _DOORLOPEN := DLopen;
  _XPos := Xpos;
  _YPos := YPos;
  For Y := 0 To 13 Do Begin
    For X := 0 To 23 Do Begin
      I := Bld.Buffer[Y+1,X+1];
      {OPBOUW BEELD}
      If (I In OpBouw) Then
        TDraw_BitMap(_SpriteRec[I]^.Buffer,(X*15)+Xpos,(Y*15)+Ypos,15,15);
      {DISKMAN OP BEELD}
      If (I = _DMStil) And (_DiskManBoolean = False) Then Begin
        _DiskMan.XPos := (X*15)+Xpos;
        _DiskMan.YPos := (Y*15)+Ypos;
        _DiskMan.Active := True;
        Move(_SpriteRec[I]^,_DiskMan.Buffer,SizeOf(_SpriteRec[I]^));
        {_DiskManBuf := _DiskMan;}
        _DiskMan.XRow := X+1;
        _DiskMan.YRow := Y+1;
        _DiskManBoolean := True;
        _HuidigeScreen.Buffer[Y+1,X+1] := 0;
      End;
    End;
  End;
  Copy_Page(0,1);
  Copy_Page(0,2);
  DrawAllSprites; {MAG NIET HIER, ALLEEN VOOR TEST}
  Set_Display_Page(0);
End;

{$I MOVEDMAN.INC}


Procedure Start_Animate;
Begin
  HaalToetsen;
  Set_Active_Page(_CurrentPage);
  UpDateAllSprites;
  BeweegDiskMan;
  DrawAllSprites;
  Set_Display_Page(_Currentpage);
  RemoveAllSprites;
  _LastPage := (_LastPage+1) MOD 2;
  _CurrentPage := (_CurrentPage+1) MOD 2;
  If (ESCAPE = True) Then _STOP := True;
End;

Begin
  _MAX_SCREEN := 0;
  _MAX_SPRITE := 0;
  _MAX_FONT := 0;
End.