Program DiskManGame;

Uses Dos,Crt,Toetsen,{SpelInt9}Timer,AdLib,PavtSnd;

{$I MODE.INC}

Const DOORLOPEN  : Set Of Byte = [0,71,72,101..126];
      SCR_X      = 24;  {X Dimensie}
      SCR_Y      = 14;  {Y Dimensie}
      MAXSCREEN  = 100;
      MAXSPRITE  = 250;
      MAXFONT    = 255;
      SCR_STR_X  = 0;   {Start opbouw screen X}
      SCR_STR_Y  = 30;  {Start opbouw screen Y}
      BITS       = 3;   {Schuif zoveel bits}
      B          = 15;
      H          = 15;
      PALNAAM    = 'PRIME.PAL';
      SPRITENAAM = 'SPRITE15.SPR';
      SCREENNAAM = 'SCREEN15.SCR';
      FONTNAAM   = 'FONT8X8.FNT';

      ANIMDELAY  = 5;
      MAXALIENS  = 6; {6}
      IMMFACTOR  = 6;   {0 = Direct aanvallen van VIJAND}
      VERTRAGING = 9;  {18 Milliseconden}

      DM_Links   = 1;
      DM_Rechts  = 2;
      DM_Onder   = 3;
      DM_Boven   = 4;

      {SPRITE CONSTANTEN}
      Leeg        = 0;
      Cursor      = 1;
      DMStil      = 2;
      DMDood      = 3;
      DMLinks1    = 4;
      DMLinks2    = 5;
      DMRechts1   = 6;
      DMRechts2   = 7;

      Scotty      = 51; { 51 t/m 60 }
      DiskManDood = 61; { 61 t/m 70 }

      Pil         = 71;
      Energie     = 72;


{$I WOORDEN.INC}
{$I SOUNDS.INC}

TYPE Sprite       = Record
                      Buffer : Array[1..B*H] Of Byte;
                      XRow   : INTEGER;
                      YRow   : INTEGER;
	              Xpos   : INTEGER;
	              Ypos   : INTEGER;
	              LastX  : INTEGER;
	              LastY  : INTEGER;
                      Active : Boolean;
                    END;

     PaletteRec   = Record
                      Red   : Byte;
                      Green : Byte;
                      Blue  : Byte;
                    End;
     PaletteArr   = Array [0..255] of PaletteRec;

     SpriteWijzer = ^SpriteDef;
     SpriteDef    = RECORD
                      Buffer : Array[1..H,1..B] Of Byte;
                    END;

     FontWijzer   = ^FontDef;
     FontDef      = RECORD
                      Buffer : Array[1..8,1..8] Of Byte;
                    END;

     ScreenWijzer = ^ScreenDef;
     ScreenDef    = RECORD
                      Buffer : Array[1..SCR_Y,1..SCR_X] Of Byte;
                    END;

     HiScoreType  = RECORD
                      Score : Array[1..11] Of LongInt;
                      Level : Array[1..11] Of Byte;
                    END;

     SpriteMemory = Array[0..MAXSPRITE] Of SpriteWijzer;
     ScreenMemory = Array[1..MAXSCREEN] Of ScreenWijzer;
     FontMemory   = Array[0..255] Of FontWijzer;

     BufMemory    = ARRAY[1..32] Of SpriteWijzer;


Var HiScoreRec     : HiScoreType;
    HiScoreFile    : File Of HiScoreType;
    GReadyRec,
    GOverRec,
    BufferRec      : BufMemory;
    SpriteRec      : SpriteMemory;
    SpriteOnes     : SpriteDef;
    ScreenRec      : ScreenMemory;
    ScreenOnes     : ScreenDef;
    FontRec        : FontMemory;
    FontOnes       : FontDef;
    SpriteFile     : File Of SpriteDef;
    ScreenFile     : File Of ScreenDef;
    FontFile       : File Of FontDef;
    Palette        : PaletteArr;
    BewaarPalette  : PaletteArr;
    PaletteBuffer  : PaletteArr;
    DiskMan        : Sprite;
    DiskManBuf     : Sprite;
    Vijand         : Array[1..MAXALIENS] Of Sprite;
    VijandBuf      : Array[1..MAXALIENS] Of Sprite;

    CurrentPage,
    LastPage       : Integer; {PAGE FLIPPING}

    AllesOpGegeten : Word;

    DiskmanBits,
    DiskLaatste,
    LinksRechts,
    AnimatieDelay,
    Animatie       : Word;

    VijandTrue     : Array[1..MAXALIENS] Of Boolean;
    VijandAantal   : Word;
    AlienLOrR,
    Kijk,
    AlienLaatste,
    AlienShape,
    AlienBits      : Array[1..MAXALIENS] Of Word;

    Trans          : Byte;
    DMDoodGaan     : Byte;

    DOOD,
    DOODLOOP,
    TRANSHORR1,
    TRANSHORL1,
    TRANSVERO1,
    TRANSVERB1,
    TRANSSECOND,
    DO_NOT_MOVE    : Boolean;
    SCREEN_NR      : Word;

    Levens         : Integer;
    WoordTel       : Byte;     {Zoek Woord Op Beeld}


    Zijkant        : MuziekType;
    EetPil         : MuziekType;
    IkGaDood       : MuziekType;

    XEDUARD        : Word;
    XEDUARDFORWARD : Boolean;

    THEEND         : Boolean;
    Wijzer         : Byte;

{$I FILEIO.INC}    {DIVERSE DISK LEES/SCHRIJF ROUTINES}
{$I PALETTE.INC}   {FADE BEELDSCHERM}

Procedure Init_All;
Begin
  Randomize;
  FillChar(DiskMan,SizeOf(DiskMan),0);
  FillChar(Vijand,SizeOf(Vijand),0);
  FillChar(AlienBits,SizeOf(AlienBits),0);
  FillChar(Kijk,SizeOf(Kijk),0);
  AnimatieDelay := ANIMDELAY;
  VijandAantal := 0;
  AllesOpgegeten := 0;
  DiskManBits := 0;
  DiskLaatste := 0;
  CurrentPage := 1;
  LastPage := 0;
  Animatie := 0;
  WoordTel := 1;
  Trans := Scotty;
  DMDoodGaan := DiskManDood;
  DOOD := FALSE;
  DOODLOOP := FALSE;
  LINKS := FALSE;
  RECHTS := FALSE;
  BOVEN := FALSE;
  ONDER := FALSE;
  DO_NOT_MOVE := FALSE;
  TRANSHORR1 := FALSE;
  TRANSHORL1 := FALSE;
  TRANSSECOND := FALSE;
  TRANSVERO1 := FALSE;
  TRANSVERB1 := FALSE;
  SetPalette;
End;


Procedure BufToDMan(Van : Byte);
Begin
  Move(SpriteRec[Van]^,DiskMan.Buffer,SizeOf(SpriteRec[Van]^));
End;

Procedure BufToVijand(W,Van : Byte);
Begin
  Move(SpriteRec[Van]^,Vijand[W].Buffer,SizeOf(SpriteRec[Van]^));
End;

Procedure DiskManInit(X,Y : Word);
Begin
  DiskMan.XPos := X;
  DiskMan.YPos := Y;
  DiskMan.Active := True;
  BufToDMan(DMStil);
End;

Procedure VijandInit(W,Shape,X,Y : Word);
Begin
  Vijand[W].XPos := X;
  Vijand[W].YPos := Y;
  Vijand[W].Active := True;
  VijandTrue[W] := True;
  BufToVijand(W,Shape);
  AlienShape[W] := Shape; {WELKE TYPE VIJAND}
End;

Procedure UpDateAllSprites;
Var I : Word;
Begin
  If DiskMan.Active = True Then Begin
    DiskMan.LastX := DiskMan.XPos;
    DiskMan.LastY := DiskMan.YPos;
  End;
  For I := 1 To MAXALIENS Do If Vijand[I].Active = True Then Begin
    Vijand[I].LastX := Vijand[I].Xpos;
    Vijand[I].LastY := Vijand[I].Ypos;
  End;
End;

Procedure DrawAllSprites;
Var I : Byte;
Begin
  If DiskMan.Active = True Then
    TDraw_Bitmap(DiskMan.Buffer,DiskMan.XPos,DiskMan.YPos,B,H);
  For I := 1 To MAXALIENS Do If Vijand[I].Active = True Then
    TDraw_Bitmap(Vijand[I].Buffer,Vijand[I].XPos,Vijand[I].YPos,B,H);
End;

Procedure RemoveAllSprites;
Var I : Byte;
Begin
  Copy_Bitmap(2,DiskMan.LastX,DiskMan.LastY,DiskMan.LastX+B,
      DiskMan.LastY+H,LastPage,DiskMan.LastX,DiskMan.LastY);
  For I := 1 To MAXALIENS Do
    Copy_Bitmap(2,Vijand[I].LastX,Vijand[I].LastY,Vijand[I].LastX+B,
        Vijand[I].LastY+H,LastPage,Vijand[I].LastX,Vijand[I].LastY);
End;

Procedure TPrint_Text(S : String; X,Y : Integer);
Var I,N : Byte;
Begin
  For I := 1 to Length(S) Do Begin
    N := Ord(S[I]);
    TDraw_BitMap(FontRec[N]^.Buffer,X,Y,8,8);
    Inc(X,10);
  End;
End;

Procedure Print_Text(S : String; X,Y : Integer);
Var I,N : Byte;
Begin
  For I := 1 to Length(S) Do Begin
    N := Ord(S[I]);
    Draw_BitMap(FontRec[N]^.Buffer,X,Y,8,8);
    Inc(X,10);
  End;
End;


Procedure Print_Score(X : Word);
Var I1,I2 : String[7];
Begin
  Str(HiScoreRec.Score[11],I1);While (Length(I1) <> 7) Do I1 := '0' + I1;
  Str(HiScoreRec.Score[ 1],I2);While (Length(I2) <> 7) Do I2 := '0' + I2;
  Print_Text(I1,X+SCR_STR_X,11);
  Print_Text(I2,X+SCR_STR_X,27);
  If (HiScoreRec.Score[11] > HiScoreRec.Score[1]) Then Begin
    HiScoreRec.Score[1] := HiScoreRec.Score[11];
  End;
End;

Procedure Print_Level(S : LongInt; X : Word);
Var I : String[3];
Begin
  Str(S,I);
  While (Length(I) <> 3) Do I := '0' + I;
  Print_Text(I,X+SCR_STR_X,11);
End;

Procedure Print_Procent(X : Word);
Var I : String[3];
    S : Word;
Begin
  S := AllesOpgegeten;
  Str(S,I);
  While (Length(I) <> 3) Do I := '0' + I;
  Print_Text(I,X+SCR_STR_X,27);
End;


Procedure GetBuffer;
Var Y,X,SX,SY,S : Byte;
Const TabelX : Array[1..15] Of Byte = (7,12,1,9,4,11,15,6,2,13,10,3,8,14,5);
      TabelY : Array[1..15] Of Byte = (15,6,9,3,11,7,4,1,13,8,12,5,10,14,2);
Begin
  S := 1;
  For SY := 1 To 15 Do Begin
    For SX := 1 To 15 Do Begin
      For Y := 1 To 4 Do Begin
        For X := 1 To 8 Do Begin
          Set_Point(105+TabelX[SX]+(X*15),90+TabelY[SY]+(Y*15),BufferRec[S]^.Buffer[TabelY[SY],TabelX[SX]]);
          Inc(S);
        End;
      End;
      S := 1;
    End;
  End;
End;

Procedure GetReady(GR : BufMemory; D : Word);
Var Y,X,SX,SY,S : Byte;
Const TabelX : Array[1..15] Of Byte = (7,12,1,9,4,11,15,6,2,13,10,3,8,14,5);
      TabelY : Array[1..15] Of Byte = (15,6,9,3,11,7,4,1,13,8,12,5,10,14,2);
Begin
  S := 1;
  For SY := 1 To 15 Do Begin
    For SX := 1 To 15 Do Begin
      For Y := 1 To 4 Do Begin
        For X := 1 To 8 Do Begin
          BufferRec[S]^.Buffer[TabelY[SY],TabelX[SX]] := Read_Point(105+TabelX[SX]+(X*15),90+TabelY[SY]+(Y*15));
          Set_Point(105+TabelX[SX]+(X*15),90+TabelY[SY]+(Y*15),GR[S]^.Buffer[TabelY[SY],TabelX[SX]]);
          Inc(S);
        End;
      End;
      S := 1;
    End;
  End;
  Delay(D);
  GetBuffer;
  Delay(500);
  ESCAPE := FALSE;
  SPATIE := FALSE;
End;

{$I DIVERSEN.INC}
{$I VIJAND.INC}
{$I DISKMAN.INC}

Procedure BeeldOpbouw;
Var X,Y,P  : Byte;
    I,Line : Word;
Begin
  Set_Active_Page(0);
  Clear_Vga_Screen(0);
  Set_Display_Page(1);
  Init_All;
  For Y := 0 To SCR_Y-1 Do Begin
    For X := 0 To SCR_X-1 Do Begin
      I := ScreenOnes.Buffer[Y+1,X+1];

      {OPBOUW BEELD}
      If (I In [Leeg,71,72,80..MAXSPRITE]) Then
         TDraw_Bitmap(SpriteRec[I]^.Buffer,(X*B)+SCR_STR_X,(Y*H)+SCR_STR_Y,B,H);

      {DISKMAN}
      If (I = DMStil) Then Begin
        DiskManInit((X*B)+SCR_STR_X,(Y*H)+SCR_STR_Y);
        DiskMan.XRow := X+1;
        DiskMan.YRow := Y+1;
        DiskManBuf := DiskMan;
        ScreenOnes.Buffer[Y+1,X+1] := 0;
      End;

      {VIJAND}
      If (I In [10,12,14,16,18,20,22,24,26,28,30,32,34,36,38,40]) Then Begin
        If (VijandAantal < MAXALIENS) Then Begin
          Inc(VijandAantal);
          VijandInit(VijandAantal,I,X*B+SCR_STR_X,Y*H+SCR_STR_Y);
          Vijand[VijandAantal].XRow := X+1;
          Vijand[VijandAantal].YRow := Y+1;
          VijandBuf[VijandAantal] := Vijand[VijandAantal];
          ScreenOnes.Buffer[Y+1,X+1] := 0;
        End;
      End;

      {TELLER VOOR OPETEN}
      If (I In [Pil,Energie]) Then Inc(AllesOpgegeten);
    End;
  End;
  Draw_BitMap(SpriteRec[215]^.Buffer,0,1,B,H);
  Draw_bitMap(SpriteRec[223]^.Buffer,15,1,B,H);
  Draw_BitMap(SpriteRec[223]^.Buffer,30,1,B,H);
  Draw_bitMap(SpriteRec[223]^.Buffer,45,1,B,H);
  Draw_BitMap(SpriteRec[226]^.Buffer,60,1,B,H);
  Draw_BitMap(SpriteRec[216]^.Buffer,75,1,B,H);
  Draw_BitMap(SpriteRec[216]^.Buffer,90,1,B,H);
  Draw_BitMap(SpriteRec[216]^.Buffer,105,1,B,H);
  Draw_BitMap(SpriteRec[216]^.Buffer,120,1,B,H);
  Draw_BitMap(SpriteRec[229]^.Buffer,135,1,B,H);

  Draw_BitMap(SpriteRec[223]^.Buffer,150,1,B,H);
  Draw_BitMap(SpriteRec[223]^.Buffer,165,1,B,H);
  Draw_BitMap(SpriteRec[223]^.Buffer,180,1,B,H);
  Draw_BitMap(SpriteRec[235]^.Buffer,195,1,B,H);   {*}
  Draw_BitMap(SpriteRec[216]^.Buffer,210,1,B,H);
  Draw_BitMap(SpriteRec[232]^.Buffer,225,1,B,H);
  Draw_BitMap(SpriteRec[223]^.Buffer,240,1,B,H);
  Draw_BitMap(SpriteRec[223]^.Buffer,255,1,B,H);
  Draw_BitMap(SpriteRec[223]^.Buffer,270,1,B,H);
  Draw_BitMap(SpriteRec[223]^.Buffer,285,1,B,H);
  Draw_BitMap(SpriteRec[223]^.Buffer,300,1,B,H);
  Draw_BitMap(SpriteRec[223]^.Buffer,315,1,B,H);
  Draw_BitMap(SpriteRec[223]^.Buffer,330,1,B,H);
  Draw_BitMap(SpriteRec[217]^.Buffer,345,1,B,H);

  Draw_BitMap(SpriteRec[218]^.Buffer,0,16,B,H);
  Draw_BitMap(SpriteRec[210]^.Buffer,15,16,B,H);
  Draw_BitMap(SpriteRec[210]^.Buffer,30,16,B,H);
  Draw_BitMap(SpriteRec[210]^.Buffer,45,16,B,H);
  Draw_BitMap(SpriteRec[227]^.Buffer,60,16,B,H);
  Draw_BitMap(SpriteRec[219]^.Buffer,75,16,B,H);
  Draw_BitMap(SpriteRec[219]^.Buffer,90,16,B,H);
  Draw_BitMap(SpriteRec[219]^.Buffer,105,16,B,H);
  Draw_BitMap(SpriteRec[219]^.Buffer,120,16,B,H);
  Draw_BitMap(SpriteRec[230]^.Buffer,135,16,B,H);

  Draw_BitMap(SpriteRec[210]^.Buffer,150,16,B,H);
  Draw_BitMap(SpriteRec[210]^.Buffer,165,16,B,H);
  Draw_BitMap(SpriteRec[210]^.Buffer,180,16,B,H);
  Draw_BitMap(SpriteRec[236]^.Buffer,195,16,B,H);  {*}
  Draw_BitMap(SpriteRec[219]^.Buffer,210,16,B,H);
  Draw_BitMap(SpriteRec[233]^.Buffer,225,16,B,H);
  Draw_BitMap(SpriteRec[210]^.Buffer,240,16,B,H);
  Draw_BitMap(SpriteRec[210]^.Buffer,255,16,B,H);
  Draw_BitMap(SpriteRec[210]^.Buffer,270,16,B,H);
  Draw_BitMap(SpriteRec[210]^.Buffer,285,16,B,H);
  Draw_BitMap(SpriteRec[210]^.Buffer,300,16,B,H);
  Draw_BitMap(SpriteRec[210]^.Buffer,315,16,B,H);
  Draw_BitMap(SpriteRec[210]^.Buffer,330,16,B,H);
  Draw_BitMap(SpriteRec[220]^.Buffer,345,16,B,H);

  TPrint_Text('SCORE', 10,10);
  TPrint_Text('   HI', 10,26);
  TPrint_Text('LEVEL',150,10);
  TPrint_Text('  PCT',150,26);
  TPrint_Text('LIVES',245,10);

  Print_Score(67);
  Print_Level(SCREEN_NR,207);

  FILL_BLOCK (300,8,350,18,27);
  For P := 1 To Levens Do
    TDraw_BitMap(FontRec[0]^.Buffer,350-(P*10),9,8,8);

  Copy_Page(0,1);
  Copy_Page(0,2);
  DrawAllSprites;
  Set_Display_Page(0);
End;

Procedure YouAreDead;
Var I,DM,Count : Byte;
Begin
  Dec(Levens);
  NoSound;
  Delay(500);
  If Sounds_Left > 0 Then Sound_Finish;
   If (Levens > 0) Then Begin
    PaletteNaarBuffer;
    DOOD := False;
    DOODLOOP := FALSE;
    LINKS := FALSE;
    RECHTS := FALSE;
    BOVEN := FALSE;
    ONDER := FALSE;
    DiskManBits := 0;
    DiskLaatste := 0;
    FillChar(Kijk,SizeOf(Kijk),0);
    FillChar(AlienBits,SizeOf(AlienBits),0);
    DiskMan := DiskManBuf;
    For I := 1 To VijandAantal Do Vijand[I] := VijandBuf[I];
    Set_Active_Page(2);
    FILL_BLOCK (300,8,350,18,27);
    For Count := 1 To Levens Do
      TDraw_BitMap(FontRec[0]^.Buffer,350-(Count*10),9,8,8);
    Set_Active_Page(0);
    Set_Display_Page(0);
    Copy_Page(2,1);
    Copy_Page(2,0);
    DrawAllSprites;
    BufferNaarPalette;
    GetReady(GReadyRec,1000);
  End;
End;

Procedure BeweegSprites;
Var Dummy : LongInt;
Begin
  TransFormDiskMan;
  CheckDoodGaan;
  BeweegDiskMan;
  BeweegVijand;
  For Dummy := 1 To 7500 Do Begin End;
End;

Procedure Start_Game;
Begin
  HaalToetsen;
  Set_Active_Page(CurrentPage);
  UpDateAllSprites;
  BeweegSprites;
  DrawAllSprites;
  Print_Score(67);
  Print_Procent(207);
  Set_Display_Page(currentpage);
  RemoveAllSprites;
  LastPage := (LastPage+1) MOD 2;
  CurrentPage := (CurrentPage+1) MOD 2;
End;

Procedure LeesPalette(S : String);
Var T,Reg : Byte;
    F : File;
    R,G,B : Byte;
    Gelezen : Word;
Begin
  If Exist(S) Then Begin
    Assign(F,S);
    Reset(F,1);
    BlockRead(F,Palette,SizeOf(Palette),Gelezen);
    Close(F);
  End;
End;

Procedure Intro(VAR Wijzer : Byte);
Var X,Y,I         : Word;
    Animate,
    EindeAnimate,
    LoopAnimate,
    XWijzer,
    YWijzer       : Word;

Begin
  BewaarPalette := Palette;
  Palette := PaletteBuffer;
  PaletteBuffer := BewaarPalette;
  Set_Active_Page(1);
  Clear_VGA_Screen(0);
  Set_Display_Page(0);
  SetPalette;
  For Y := 0 To 13 Do Begin
    For X := 0 To 23 Do Begin
      I := ScreenRec[100]^.Buffer[Y+1,X+1];
      TDraw_Bitmap(SpriteRec[I]^.Buffer,(X*B),(Y*H),B,H);
    End;
  End;
  For X := 0 To 11 Do Begin
    I := ScreenRec[100]^.Buffer[1,1];
    TDraw_Bitmap(SpriteRec[I]^.Buffer,X*30,210,B,H);
    I := ScreenRec[100]^.Buffer[1,2];
    TDraw_Bitmap(SpriteRec[I]^.Buffer,15+(X*30),210,B,H);
    I := ScreenRec[100]^.Buffer[2,1];
    TDraw_Bitmap(SpriteRec[I]^.Buffer,X*30,225,B,H);
    I := ScreenRec[100]^.Buffer[2,2];
    TDraw_Bitmap(SpriteRec[I]^.Buffer,15+(X*30),225,B,H);
  End;
  TPrint_Text('PLAY_DISKMAN',130, 50);
  TPrint_Text('HI_SCORE____',130, 70);
  TPrint_Text('INFO________',130, 90);
  TPrint_Text('EXIT________',130,110);
  Set_Display_Page(1);
  BufferNaarPalette;
  Animate := 10;
  LoopAnimate := Animate;
  EindeAnimate := 19;
  Wijzer := 1;
  XWijzer := 105;
  YWijzer := 50;
  ENTER := FALSE;
  Repeat
    Repeat Until TijdTeller > 1;
    TijdTeller := 0;
    Print_Text(Chr(LoopAnimate),XWijzer,YWijzer);
    Inc(LoopAnimate);
    If LoopAnimate > EindeAnimate Then LoopAnimate := Animate;
    HaalToetsen;
    If (ONDER = True) Then Begin
        Print_Text(Chr(20),XWijzer,YWijzer);
        Inc(Wijzer);
        Inc(YWijzer,20);
        If (YWijzer = 130) Then Begin
          YWijzer := 50;
          Wijzer := 1;
        End;
        ONDER := False;
    End;
  Until (ENTER = True);
  ENTER := FALSE;
End;

Procedure CheckHiScore;
Var N,M : Byte;

  (*
  Procedure Wissel(MM : Byte);
  Begin
    Temp := HiScore
    HiScoreRec.Score[MM] := HiScoreRec.Score[MM+1];
    HiScoreRec.Level[MM] := HiScoreRec.Level[MM+1];
  End;
  *)

Begin
  With HiScoreRec Do Begin
    For N := 1 To 10 Do
      For M := 1 To 11-N Do If Score[M+1] > Score[M] Then ; {Wissel(M)}
  End;
End;

Procedure DiskMan_Start;
Var DoodCheck : Byte;
    P : Byte;
Begin
  DOOD := False;
  ESCAPE := False;
  SCREEN_NR := 1;
  ScreenOnes := ScreenRec[SCREEN_NR]^;
  Levens := 3;
  WoordTel := 1;
  BeeldOpBouw;
  GetReady(GReadyRec,1000);
  While Not ESCAPE DO Begin
    Start_Game;
    If (DOOD = TRUE) Then YouAreDead;
    If (WoordTel > 5) Then Begin
      NoSound;
      NoSound2;
      Inc(SCREEN_NR); If (SCREEN_NR = 11) Then SCREEN_NR := 1;
      ScreenOnes := ScreenRec[SCREEN_NR]^;
      PaletteNaarBuffer;
      BewaarPalette := Palette;
      BeeldOpBouw;
      Palette := BewaarPalette;
      BufferNaarPalette;
      SPATIE := FALSE;
      GetReady(GReadyRec,1000);
    End;
    NoSound2;
    If (Levens = 0) Then Begin
      GetReady(GOverRec,5000);
      Break;
    End;
  End;
  CheckHiScore;
END;

Procedure MaakGetReady;
Var S,Y,X : Byte;
Const GR  : Array[1..32] of Byte = (238,242,242,242,242,242,242,239,
                                    243,188,191,197,246,246,246,245,
                                    243,246,194,191,189,195,196,245,
                                    241,244,244,244,244,244,244,240);
Begin
  For S := 1 To 32 Do Begin
    GetMem(GReadyRec[S],SizeOf(SpriteOnes)); {GET READY}
    GetMem(BufferRec[S],SizeOf(SpriteOnes)); {BUFFER VOOR GET READY}
    GReadyRec[S]^ := SpriteRec[GR[S]]^;
  End;
End;

Procedure MaakGameOver;
Var S,Y,X : Byte;
Const GR  : Array[1..32] Of Byte = (238,242,242,242,242,242,242,239,
                                    243,246,160,161,162,163,246,245,
                                    243,246,164,165,163,166,246,245,
                                    241,244,244,244,244,244,244,240);

Begin
  For S := 1 To 32 Do Begin
    GetMem(GOverRec[S],SizeOf(SpriteOnes)); {GET READY}
    GOverRec[S]^ := SpriteRec[GR[S]]^;
  End;
End;


Procedure Loader;
Begin
  WriteLn('Ŀ');
  WriteLn(' DISKMAN'+Chr(39)+'S JOURNEY PART 1    (C) EDU 1994 ');
  WriteLn('');
  WriteLn('Available memory : ',MaxAvail);
  WriteLn('Reading Graphics...');
  HaalHiScore;
  HaalFont;
  HaalSprites;
  HaalScreen;
  MaakGetReady;
  MaakGameOver;
  LeesPalette(PALNAAM);
  IF SET_VGA_MODEX(6,360,240,3) = 0 THEN Begin
    WriteLn('Unable to SET_VGA_MODEX');
    Halt(0);
  End;
End;

Procedure SpelInit;
Var Edu : Word;
Begin
  ClrScr;
  HiScoreRec.Score[11] := 0;
  HiScoreRec.Level[11] := 0;
  Levens := 3;
  FillChar(Zijkant,SizeOf(Zijkant),0);
  FillChar(IkGaDood,SizeOf(IkGaDood),0);
  FillChar(EetPil,SizeOf(Eet),0);
  For Edu := 1 To 12 Do Zijkant[Edu]  := Riff[Edu];
  For Edu := 1 To  3 Do EetPil[Edu]   := Eet[Edu];
  For Edu := 1 To 42 Do IkGaDood[Edu] := Dead[Edu];
  XEDUARD := 241;
  XEDUARDFORWARD := TRUE;
End;

Procedure BackToDos; ASSEMBLER;
ASM
  Mov AH,0
  Mov AL,3
  Int 10h
END;

Function IntToStr(I : LongInt; A : Byte) : String;
Var S : String[11];
Begin
  Str(I,S);
  While Length(S) < A Do S := '0' + S;
  IntToStr := S;
End;

Begin
  Loader;
  SpelInit;
  THEEND := False;
  Wijzer := 1;
  Repeat
    Intro(Wijzer);
    If (Wijzer = 1) Then DiskMan_Start;
    If (Wijzer = 4) Then THEEND := True;
  Until (THEEND = TRUE);
  SchrijfHiScore;
  BackToDos;
END.