Program Demo;

Uses Dos,Crt;

{$L modex.obj}		{ This file is the external ModeX Library .OBJ }
{$F+}
{ Mode Setting Routines }
Function SET_VGA_MODEX (Mode,MaxXpos,MaxYpos,Pages : integer) : integer; external;
Function SET_MODEX (Mode:integer) : Integer; external;

{ Graphics Primitives }
Procedure CLEAR_VGA_SCREEN (Color:integer); external;
Procedure SET_POINT (Xpos,Ypos,Color : integer); external;
Function READ_POINT (Xpos,Ypos:integer) : integer; external;
Procedure FILL_BLOCK (Xpos1,Ypos1,Xpos2,Ypos2,Color:integer); external;
Procedure DRAW_LINE (Xpos1,Ypos1,Xpos2,Ypos2,Color:integer); external;

{ VGA DAC Routines }
Procedure SET_DAC_REGISTER (RegNo,Red,Green,Blue:integer); external;
Procedure GET_DAC_REGISTER (RegNo,Red,Green,Blue:integer); external;
Procedure LOAD_DAC_REGISTERS(Var PalData; StartReg, EndReg : Integer; Sync : Boolean); External;
Procedure READ_DAC_REGISTERS(Var PalData; StartReg, EndReg : Integer); External;

{ Page and Window Control Routines }
Procedure SET_ACTIVE_PAGE (PageNo:integer); external;
Function GET_ACTIVE_PAGE : integer; external;
Procedure SET_DISPLAY_PAGE (PageNo:integer); external;
Function GET_DISPLAY_PAGE : integer; external;
Procedure SET_WINDOW (DisplayPage,XOffset,YOffset : integer); external;
Function GET_X_OFFSET : integer; external;
Function GET_Y_OFFSET : integer; external;
Procedure SYNC_DISPLAY; external;

{ Text Display Routines }
Procedure GPRINTC (CharNum,Xpos,Ypos,ColorF,ColorB:integer); external;
Procedure TGPRINTC ( CharNum,Xpos,Ypos,ColorF : integer); external;
Procedure PRINT_STR (Var Text;MaxLen,Xpos,Ypos,ColorF,ColorB:integer); external;
Procedure TPRINT_STR (Var Text;MaxLen,Xpos,Ypos,ColorF:integer); external;
Procedure SET_DISPLAY_FONT (Var FontData;FontNumber:integer); external;

{ Sprite and VGA memory -> Vga memory Copy Routines }
Procedure DRAW_BITMAP (Var Image;Xpos,Ypos,Width,Height:integer); external;
Procedure TDRAW_BITMAP (Var Image;Xpos,Ypos,Width,Height:integer); external;
Procedure COPY_PAGE (SourcePage,DestPage:integer); external;
Procedure COPY_BITMAP (SourcePage,X1,Y1,X2,Y2,DestPage,DestX1,DestY1:integer); external;
{$F-}

Const XVELD      = 24;  {X Dimensie}
      YVELD      = 14;  {Y Dimensie}
      XSTART     = 0;
      YSTART     = 28;
      BREEDTE    = 15;
      HOOGTE     = 15;
      MAXSCREEN  = 100;
      MAXSPRITE  = 250;
      MAXFONT    = 255;
      BUFFERNAAM = 'SPRITE15.BUF';
      SPRITENAAM = 'SPRITE15.SPR';
      SCREENNAAM = 'SCREEN15.SCR';
      FONTNAAM   = 'FONT8X8.FNT';
      SPRITEINC  = 'SPRDATA.INC';
      FONTINC    = 'DIGITS.INC';
      PALNAAM    = 'PRIME.PAL';

      Beeldje    : Array[1..16,1..22] Of Byte = (
      (07,07,07,07,07,07,07,07,07,07,07,07,07,07,07,07,07,07,07,07,07,07),
      (07,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,07),
      (07,00,07,07,07,07,00,07,00,07,07,07,07,00,07,00,07,07,07,07,00,07),
      (07,00,07,00,00,07,00,07,00,00,07,07,00,00,07,00,07,00,00,07,00,07),
      (07,00,07,00,00,07,00,07,07,00,00,00,00,07,07,00,07,00,00,07,00,07),
      (07,00,07,07,07,07,00,00,07,00,07,07,00,07,00,00,07,07,07,07,00,07),
      (07,00,00,00,00,00,00,00,07,00,00,00,00,07,00,00,00,00,00,00,00,07),
      (07,00,07,00,07,07,07,00,07,00,07,07,00,07,00,07,07,07,00,07,00,07),
      (07,00,07,00,07,07,07,00,07,00,07,07,00,07,00,07,07,07,00,07,00,07),
      (07,00,00,00,00,00,00,00,07,00,00,00,00,07,00,00,00,00,00,00,00,07),
      (07,00,07,07,07,07,00,07,07,00,07,07,00,07,07,00,07,07,07,07,00,07),
      (07,00,07,00,00,07,00,07,00,00,00,00,00,00,07,00,07,00,00,07,00,07),
      (07,00,07,00,00,07,00,07,00,00,07,07,00,00,07,00,07,00,00,07,00,07),
      (07,00,07,07,07,07,00,07,00,07,07,07,07,00,07,00,07,07,07,07,00,07),
      (07,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,07),
      (07,07,07,07,07,07,07,07,07,07,07,07,07,07,07,07,07,07,07,07,07,07));

      Wijzer     : Array[1..10,1..10] Of Byte = (
      (05,05,05,05,05,05,05, 0, 0, 0),
      (05,05,05,05,05,05,00, 0, 0, 0),
      (05,05,05,05,05,00, 0, 0, 0, 0),
      (05,05,05,05,05, 0, 0, 0, 0, 0),
      (05,05,05,05,05,05, 0, 0, 0, 0),
      (05,05, 0,05,05,05,05, 0, 0, 0),
      (05, 0, 0, 0,05,05,05,05, 0, 0),
      ( 0, 0, 0, 0, 0,05,05,05,05, 0),
      ( 0, 0, 0, 0, 0, 0,05,05,05, 0),
      ( 0, 0, 0, 0, 0, 0, 0,05,05, 0));


Type  SpriteWijzer = ^SpriteDef;
      SpriteDef    = RECORD
                       Buffer : Array[1..HOOGTE,1..BREEDTE] Of Byte;
                     END;

      FontWijzer   = ^FontDef;
      FontDef      = RECORD
                       Buffer : Array[1..8,1..8] Of Byte;
                     END;

      ScreenWijzer = ^ScreenDef;
      ScreenDef    = RECORD
                       Buffer : Array[1..YVELD,1..XVELD] Of Byte;
                     END;

      SpriteMemory = Array[0..MAXSPRITE] Of SpriteWijzer;
      ScreenMemory = Array[1..MAXSCREEN] Of ScreenWijzer;
      FontMemory   = Array[0..255] Of FontWijzer;

      BufferType1  = Array[0..9] Of SpriteDef;


Var   SpriteRec    : SpriteMemory;
      SpriteOnes   : SpriteDef;
      ScreenRec    : ScreenMemory;
      ScreenOnes   : ScreenDef;
      ScreenBuffer : ScreenDef;
      FontRec      : FontMemory;
      FontOnes     : FontDef;
      SpriteFile   : File Of SpriteDef;
      ScreenFile   : File Of ScreenDef;
      FontFile     : File Of FontDef;

      SpriteBuf    : BufferType1;

      SprBufFile   : File Of BufferType1;
      FlipBuffer   : SpriteDef;
      FontBuffer   : FontDef;

      SpriteTeller,
      ScreenTeller,
      FontTeller,
      KleurTeller,
      ColorX,
      ColorY       : Integer;

      Palette      : Array[0..255,1..3] Of Byte;
      WijzerBuffer : Array[1..15,1..15] Of Byte;

      SPREDIT      : BOOLEAN;
      SCREDIT      : BOOLEAN;
      FNTEDIT      : BOOLEAN;
      EINDE        : BOOLEAN;

      FONTGEWERKT,
      SPRITEGEWERKT,
      SCREENGEWERKT : BOOLEAN;


{$I FILEIO.ED}

Procedure InitBuffer;
Begin
  FillChar(SpriteBuf,SizeOf(SpriteBuf),0);
  SpriteBuf[0] := SpriteRec[02]^;
  SpriteBuf[1] := SpriteRec[08]^;
  SpriteBuf[2] := SpriteRec[12]^;
  SpriteBuf[3] := SpriteRec[16]^;
  SpriteBuf[4] := SpriteRec[20]^;
End;

Procedure HaalBuffers;
Begin
  If Not Exist(BUFFERNAAM) Then InitBuffer Else Begin
    Assign(SprBufFile,BUFFERNAAM);
    Reset(SprBufFile);
    Read(SprBufFile,SpriteBuf);
    Close(SprBufFile);
  End;
End;

Procedure SchrijfBuffers;
Begin
  Assign(SprBufFile,BUFFERNAAM);
  ReWrite(SprBufFile);
  Write(SprBufFile,SpriteBuf);
  Close(SprBufFile);
End;


Procedure Print_Text(S : String; X,Y,BColor,FColor : Integer);
Var S1 : Array[1..135] of Char;
    I  : Byte;
Begin
  For I := 1 to Length(S) DO S1[I] := S[I];
  Print_Str(S1,Length(S),X,Y,BColor,FColor);
End;

Procedure Print_Char(C : Byte; X,Y : Integer);
Begin
  Draw_BitMap(FontRec[C]^.Buffer,X,Y,8,8);

End;


Procedure Afsluiten;
Begin
   Fill_Block(100,100,262,111,7);
   Fill_Block(101,101,261,110,6);
   Sound(500);
   Delay(50);
   Sound(1000);
   Delay(50);
   NoSound;
   Print_Text('PROGRAMMA AFSLUITEN!',102,102,0,6);
End;

Procedure Beep;
Begin
  Sound(500);
  Delay(50);
  NoSound;
End;

{$I FONT.ED}
{$I SCREEN.ED}
{$I SPRITE.ED}


Procedure LeesPalette(S : String);
Var T,Reg : Byte;
    F : File;
    R,G,B : Byte;
    Gelezen : Word;
   
Begin
  If Exist(S) Then Begin
    Assign(F,S);
    Reset(F,1);
    BlockRead(F,Palette,SizeOf(Palette),Gelezen);
    Close(F);
    For T := 0 To 255 Do
      Set_Dac_Register(T,Palette[T,1],Palette[T,2],Palette[T,3]);
  End;
End;

Procedure SchrijfPalette(S : String);
Var F       : File;
    Gelezen : Word;
Begin
  Assign(F,S);
  ReWrite(F,1);
  BlockWrite(F,Palette,SizeOf(Palette),Gelezen);
  Close(F);
End;

Procedure Editor_Init;
Begin
  If Set_Vga_ModeX(6,360,240,3) = 0 Then Begin
    WriteLn('Video mode kan niet worden ge-initialiseert...');
    Halt(0);
  End;
  FONTGEWERKT := FALSE;
  SCREENGEWERKT := FALSE;
  SPRITEGEWERKT := FALSE;
  SpriteTeller := 1;
  ScreenTeller := 1;
  FontTeller   := 0;
  KleurTeller  := 0;
  ColorX := 212;
  ColorY := 5;
  HaalFont;
  HaalSprites;
  HaalScreen;
  HaalBuffers;
  Set_Active_Page(2);
  Clear_VGA_Screen(0);
  Set_Display_Page(2);
End;

Procedure Editor_Start;
Begin
  EINDE := FALSE;
  SPREDIT := FALSE;
  SCREDIT := TRUE;
  FNTEDIT := FALSE;
  Repeat
    If SCREDIT Then ScreenEditor;
    If SPREDIT Then SpriteEditor;
    If FNTEDIT Then KarakterEditor;
  Until EINDE = TRUE;
  AfSluiten;

  If FONTGEWERKT Then SchrijfFont;
  If FONTGEWERKT Then SchrijfPalette(PALNAAM);
  {If FONTGEWERKT Then Conv8x8;}
  IF SCREENGEWERKT Then SchrijfScreen;
  If SPRITEGEWERKT Then SchrijfBuffers;
  IF SPRITEGEWERKT Then SchrijfSprites;
  If SPRITEGEWERKT Then SchrijfPalette(PALNAAM);
  {If SPRITEGEWERKT Then Conv15x15;}
End;



Procedure BackToDos; ASSEMBLER;
ASM
  Mov AH,0
  Mov AL,3
  Int 10h
END;

Begin
  Editor_Init;
  LeesPalette(PALNAAM);
  Editor_Start;
  BackToDos;
END.