Unit Opslag;

INTERFACE

Const SCREEN_X = 30;
      SCREEN_Y = 20;
      SPRITE_X = 12;
      SPRITE_Y = 12;
      MOVE_X   = 0;
      MOVE_Y   = 0;

Type  ByteSet = Set Of Byte;

Type  _SprBuf_  = Array[1..SPRITE_Y*SPRITE_X] Of Byte;
      _ScrBuf_  = Array[1..SCREEN_Y,1..SCREEN_X] Of Word;

Type _PSprite = ^_TSprite;
     _TSprite = RECORD
       Welke    : Word;
       Data     : _SprBuf_;
       Volgende : _PSprite;
     END;

Var  _SpriteData  : _PSprite;
     _SpriteTemp  : _PSprite;
     _SpriteFirst : _PSprite;
     _SpriteLast  : _PSprite;
     _SpriteNieuw : _PSprite;

Var  Gems_Count   : Word;

Type FWijzer = ^FDef;
     FDef = RECORD
       Buf : Array[1..8,1..8] Of Byte;
     END;
     FMem = Array[0..255] Of FWijzer;
Var  FRec  : FMem;

Procedure ReadSprites(N : String);
Procedure GetSprite(N : Word; VAR S : _SprBuf_);
Procedure ReadFont(N : String);

IMPLEMENTATION

Procedure Error(E : String);
Begin
  Write(E);
  Halt(1);
End;

Procedure ReadSprites;
Var F : File;
    U : _SprBuf_;
    R : Word;
    C : Word;

  Function CheckEmpty : Boolean;
  Var Loop : Word;
  Begin
    CheckEmpty := True;
    For Loop := 1 To (SPRITE_Y*SPRITE_X) Do Begin
      If U[Loop] > 0 Then Begin
        CheckEmpty := False;
        Break;
      End;
    End;
  End;

  Procedure AddSpriteData;
  Begin
    If (MaxAvail > SizeOf(_TSprite)) Then Begin
      New(_SpriteNieuw);
      _SpriteNieuw^.Data := U;
      _SpriteNieuw^.Welke := C;
      If (_SpriteFirst = Nil) Then Begin
        _SpriteFirst := _SpriteNieuw;
        _SpriteData  := _SpriteNieuw;
      End Else _SpriteLast^.Volgende := _SpriteNieuw;
      _SpriteNieuw^.Volgende := Nil;
      _SpriteLast := _SpriteNieuw;
    End Else Error('Memory Error [SPRITES]');
  End;

Begin
  Assign(F,N);
  Reset(F,1);
  C := 0;
  Repeat
    BlockRead(F,U,SizeOf(_SprBuf_),R);
    If (C = 0) Then AddSpriteData Else Begin
      If (CheckEmpty = False) Then Begin
        If R = SizeOf(_SprBuf_) Then AddSpriteData;
      End;
    End;
    Inc(C);
  Until R <> SizeOf(_SprBuf_);
  Close(F);
End;

Procedure GetSprite;
Begin
  _SpriteTemp := _SpriteFirst;
  While (_SpriteTemp <> Nil) And (N <> _SpriteTemp^.Welke) Do Begin
    _SpriteTemp := _SpriteTemp^.Volgende;
  End;
  S := _SpriteTemp^.Data;
End;

Procedure ReadFont;
Var F : File;
    C : Word;
Begin
  Assign(F,N);
  Reset(F,1);
  For C := 0 To 200 Do Begin
    GetMem(FRec[C],SizeOf(FDef));
    BlockRead(F,FRec[C]^.Buf,SizeOf(FDef));
  End;
  Close(F);
End;

Begin
  _SpriteData  := Nil;
  _SpriteFirst := Nil;
End.